"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Store {
    constructor(User) {
        this.User = User;
    }
    getUsers() {
        return this.User.find();
    }
    getUserByViberUserId(viberUserId) {
        return this.User.findOne({ viberUserId });
    }
    getUserByNumber(numberIn) {
        return this.User.findOne({ number: numberIn });
    }
    getUserByTelegramChatId(telegramChatId) {
        return this.User.findOne({ telegramChatId });
    }
    getUserByViberUserIdOrNumber(viberUserId, numberIn) {
        return this.getUserByViberUserId(viberUserId)
            .then((user) => {
            if (!user) {
                return this.getUserByNumber(numberIn);
            }
            return Promise.resolve(user);
        })
            .then((user) => {
            if (!user) {
                return Promise.reject(new Error("no user"));
            }
            return Promise.resolve(user);
        });
    }
    getUserByTelegramChatIdOrNumber(telegramChatId, numberIn) {
        return this.getUserByTelegramChatId(telegramChatId)
            .then((user) => {
            if (!user) {
                return this.getUserByNumber(numberIn);
            }
            return Promise.resolve(user);
        })
            .then((user) => {
            if (!user) {
                return Promise.reject(new Error("no user"));
            }
            return Promise.resolve(user);
        });
    }
    updateByNumber(numberIn, object) {
        return this.getUserByNumber(numberIn)
            .then((user) => {
            Object.keys(object).map((key) => {
                // console.log('k->v', key, object[key]);
                user[key] = object[key];
            });
            // console.log('user', user);
            return user.save();
        });
    }
    save(object) {
        return (new this.User(object)).save();
    }
}
exports.Store = Store;
